#include<bonnet.h>

int open(char *pathname, int flags, mode_t mode)
{
	struct stat st;
	int ret;

	if(pathname == NULL)
		return 0;

	stat(pathname,&st);

	ft[next_ft_no].count = 1;
	ft[next_ft_no].offset = 0;
	ft[next_ft_no].size = st.st_size;
	ft[next_ft_no].ino = st.st_ino;
	ft[next_ft_no].flags = flags;
	ft[next_ft_no].mode = mode;
	ret = next_ft_no;

	while(next_ft_no++ < MAX_FD)
	{
		if(ft[next_ft_no].count == 0)
			break;
	}
	return ret;	
}

int creat(const char *pathname,mode_t mode)
{

}

int close(int filedes)
{
	if(ft[filedes].count == 1)
	{
		ft[filedes].count = 0;
		next_ft_no = filedes;		
		return 1;
	}
	else return 0;
}

#define DOWN_ALIGN(i) (i & 0xFFFFF000)
#define UP_ALIGN(i) DOWN_ALIGN(i) + BLKSIZE - 1

ssize_t read(int filedes, void *buffer, size_t n)
{
	ino_t ino;
	char *buf,*ptr;
	int off,eoff;
	int space,len;
	int i;

	if(filedes < 0)
		return 0;
	if(n < 0)
		return 0;

	buf = new_balloc(1);
	ino = ft[filedes].ino;

	off = ft[filedes].offset;
	eoff = ft[filedes].offset + n;

	/* check permition <- skip */

	for(i=DOWN_ALIGN(off);i<=UP_ALIGN(eoff);i+=BLKSIZE)
	{
		getblk(bmap(ino,i),buf,1);
		ptr = buf;
		space = 0;
		len = BLKSIZE;
			
		/* first */	
		if(i == 0)
		{
			space = off % BLKSIZE;
			len = BLKSIZE - space;
		}

		/* last */
		if(i == DOWN_ALIGN(eoff))
			len = (eoff % BLKSIZE) - space;

		ptr += space;
		memcpy(buffer,ptr,len);
		buffer += len;
	}
}

ssize_t write(int filedes, const void *buffer, size_t n)
{
	
}

off_t lseek(int filedes, off_t offset, int start_flag)
{
	if(filedes < 0)
		return -1;
	
	switch(start_flag)
	{
		case SEEK_SET:
			if(offset < 0)
				return -1;
			ft[filedes].offset = offset;
			break;

		case SEEK_CUR:
			ft[filedes].offset += offset;
			break;

		case SEEK_END:
			ft[filedes].offset = (ft[filedes].size -1) + offset;
			break;

		default:
			return -1;
	}
	return ft[filedes].offset;
}

int unlink(const char *pathname)
{

}

int remove(const char *pathname)
{

}

int fcntl(int filedes, int cmd, ...)
{

}
