#include<bonnet.h>

#define POWER (BLKSIZE / 512)

// read a block
int bread(int block,char *buf,int count)
{
    if(block < 0)
        return 0;

    sread(fs_info->sec_start+block*POWER,buf,count*POWER);
}

// read a block
int bwrite(int block,char *buf,int count)
{
    if(block < 0)
        return 0;

    swrite(fs_info->sec_start+block*POWER,buf,count*POWER);
}

// read a sector
int sread(int sector,char *buf,int count)
{
    int i;
    char *ptr=buf;

    if(count <= 0)
        return 0;
    for(i=0;i<count;i++)
    {
        //ide_read(sector+i,ptr,1);
		blktab.blk_op->read(sector+i,ptr,1);
        ptr+=512;
    }
    return 0;
}

// write a sector
int swrite(int sector,char *buf,int count)
{
    int i;
    char *ptr=buf;

    if(count <= 0)
        return 0;
    for(i=0;i<count;i++)
    {
        //ide_write(sector+i,ptr,1);
		blktab.blk_op->write(sector+i,ptr,1);
        ptr+=512;
    }
    return 1;
}


