#include<bonnet.h>

#define PRSB(name) printf(#name " : %d\n",sb->name);
#define PRGD(name) printf(#name " : %d\n",gd->name);

void print_group_descriptor(struct ext2_group_desc *gd)
{
	PRGD(bg_block_bitmap);
	PRGD(bg_inode_bitmap);
	PRGD(bg_free_blocks_count);
	PRGD(bg_used_dirs_count);
}

void print_super_block(struct ext2_super_block *sb)
{
	PRSB(s_block_group_nr);
	PRSB(s_inodes_count);
	PRSB(s_blocks_count);
	PRSB(s_r_blocks_count);
	PRSB(s_free_blocks_count);
	PRSB(s_free_inodes_count);
	PRSB(s_first_data_block);
	PRSB(s_log_block_size);
	PRSB(s_log_frag_size);
	PRSB(s_blocks_per_group);
	PRSB(s_frags_per_group);
	PRSB(s_inodes_per_group);
	PRSB(s_mtime);
	PRSB(s_wtime);
	PRSB(s_mnt_count);
	printf("(%c",sb->s_volume_name[0]);
	printf("%c",sb->s_volume_name[1]);
	printf("%c",sb->s_volume_name[2]);
	printf("%c",sb->s_volume_name[3]);
}
