#include<bonnet.h>

int stat(char *pathname,struct stat *buf)
{
	inode_t ino;
	struct ext2_inode *inode;

	if(!buf)
		return 0;
	if(!pathname)
		return 0;

	ino = namei(pathname);
	inode = iget(ino); /* pathname -> inode number -> inode struct */

	if(inode == NULL)
		return 0;

	buf->st_ino = ino;
	buf->st_mode = inode->i_mode;
	buf->st_uid = inode->i_uid;
	buf->st_gid = inode->i_gid;
	buf->st_size = inode->i_size;
	buf->st_blksize = fs_info->blksize;
	buf->st_atime = inode->i_atime;
	buf->st_mtime = inode->i_mtime;
	buf->st_ctime = inode->i_ctime;

	return 1;
}
